Draft BezCurve

From FreeCAD Documentation
Jump to navigation Jump to search
This page contains changes which are not marked for translation.
Under construction icon-blue.svg
This documentation is work in progress. Please don't mark it as translatable since it will change the next hours and days.
Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский
Arrow-left.svg Previous: Draft CubicBezCurve.svg CubicBezCurve
Next: Point Draft Point.svg Arrow-right.svg

Draft BezCurve.svg Draft BezCurve

Menu location
Drafting → Bézier tools → Bézier curve
Workbenches
Draft, Arch
Default shortcut
B Z
Introduced in version
0.14
See also
Draft CubicBezCurve, Draft BSpline

Description

The Draft BezCurve.svg Draft BezCurve command creates a Bézier Curve from several points. It uses the Draft Linestyle set on the Draft Tray.

The command creates a single Bézier curve of degree number_of_points - 1. It can be transformed to a piecewise Bézier curve, made up of curves of a specified degree, by changing its properties.

The Draft BezCurve and the Draft CubicBezCurve commands use control points to define the position and curvature of the spline. The Draft BSpline command, on the other hand, specifies the exact points through which the curve will pass.

Draft BezCurve Example.png

Bézier curve defined by multiple control points

Usage

  1. There are several ways to invoke the command:
    • Press the Draft BezCurve.svg Draft BezCurve button.
    • Select the Drafting → Bézier tools → Draft BezCurve.svg Bézier curve option from the menu.
    • Use the keyboard shortcut: B then Z.
  2. Click the first point in the 3D view, or type coordinates and press the Draft AddPoint.svg Enter point button in the related Line task panel.
  3. Click additional points in the 3D view, or type coordinates and press the Draft AddPoint.svg Enter point button in the related Line task panel.
  4. Press Esc or the Close button in the related Line task panel, or double-click the last point to finish the command.

Options

  • Press A or the Draft FinishLine.svg Finish button to finish the curve, leaving it open.
  • Press O or the Draft CloseLine.svg Close button to close the curve, that is, a segment will be added from the last point to the first one to form a face. At least four points, a curve of degree three, are required to form a face.
  • Press W or the Draft Wipe.svg Wipe button to remove the curve segments already placed, but keep editing the curve from the last point.
  • Press U or the Draft SelectPlane.svg Set WP button to adjust the current working plane in the orientation of the last point.
  • Press X, Y or Z after a point to constrain the next point on the given axis.
  • To enter coordinates manually, simply enter the numbers, then press Enter between each X, Y and Z component.
  • Press R or click the checkbox to toggle relative mode. If relative mode is on, the coordinates of the next point are relative to the last one; if not, they are absolute, taken from the origin (0,0,0).
  • Press T or click the checkbox to toggle continue mode. If continue mode is on, the BezCurve command will restart after you finish the curve, allowing you to draw another one without pressing the command button again.
  • Press L or click the checkbox to toggle filled mode. If filled mode is on, a closed wire will create a filled face (DataMake Face true); if not, the closed wire will not make a face (DataMake Face false).
Note: the curve should not be filled if it intersects itself, as it won't create a proper face. If the curve is filled but no shape is visible, manually set DataMake Face to false to see the curve.
  • Hold Ctrl while drawing to force snapping your point to the nearest snap location, independently of the distance.
  • Hold Shift while drawing to constrain your next point horizontally or vertically in relation to the last one.
  • Press Ctrl+Z or press the Draft UndoLine.svg Undo button to undo the last point.
  • Press Esc or the Close button to abort the current command; curve segments already placed will remain.

Notes

  • A Draft BezCurve can be edited with the Draft Edit command. Nodes can be added, removed and repositioned, and their constraint type can be changed.
  • OpenCascade, and therefore FreeCAD, does not support Bézier curves of degrees larger than 25. This should not be a problem in practice, as most users typically use Bézier curves of degrees 3 to 5.

Properties

See also: Property editor.

A Draft BezCurve object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:

Data

Draft

  • DataArea (Area): (read-only) specifies the area of the face of the curve. The value will be 0.0 if DataMake Face if false or the face cannot be created.
  • DataClosed (Bool): specifies if the curve is closed or not. If the curve is initially open this value is false, setting it to true will draw a segment to close the curve. If the curve is initially closed this value is true, setting it to false will remove the last segment and make the curve open.
  • DataContinuity (IntegerList): (read-only) specifies the continuity of the curve.
  • DataDegree (Integer): specifies the degree of the curve.
  • DataLength (Length): (read-only) specifies the total length of the curve.
  • DataMake Face (Bool): specifies if the curve makes a face or not. If it is true a face is created, otherwise only the perimeter is considered part of the object. This property only works if DataClosed is true and if the curve does not self-intersect.
  • DataPoints (VectorList): specifies the control points of the curve in its local coordinate system.

View

Draft

  • ViewArrow Size (Length): specifies the size of the symbol displayed at the end of the curve.
  • ViewArrow Type (Enumeration): specifies the type of symbol displayed at the end of the curve, which can be Dot, Circle, Arrow, Tick or Tick-2.
  • ViewEnd Arrow (Bool): specifies whether to show a symbol at the end of the curve, so it can be used as an annotation line.
  • ViewPattern (Enumeration): specifies the Draft Pattern with which to fill the face of the closed curve. This property only works if DataMake Face is true and if ViewDisplay Mode is Flat Lines.
  • ViewPattern Size (Float): specifies the size of the Draft Pattern.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft Line use the make_bezcurve method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeBezCurve method.

bezcurve = make_bezcurve(pointslist, closed=False, placement=None, face=None, support=None, degree=None)
bezcurve = make_bezcurve(Part.Wire, closed=False, placement=None, face=None, support=None, degree=None)
  • Creates a bezcurve object with the given list of points, pointslist.
    • Each point in the list is defined by its FreeCAD.Vector, with units in millimeters.
    • Alternatively, the input can be a Part.Wire, from which points are extracted.
  • If closed is True, or if the first and last points are identical, the curve is closed.
  • If placement is None the shape is created at the origin.
  • If face is True, and the wire is closed, the wire will make a face, that is, it will appear filled.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(0, 0, 0)
p2 = App.Vector(1000, 1000, 0)
p3 = App.Vector(2000, 0, 0)
p4 = App.Vector(1500, -2000, 0)

bezcurve1 = Draft.make_bezcurve([p1, p2, p3, p4], closed=True)
bezcurve2 = Draft.make_bezcurve([p4, 1.3*p2, p1, 4.1*p3], closed=True)
bezcurve3 = Draft.make_bezcurve([1.7*p3, 1.5*p4, 2.1*p2, p1], closed=True)

doc.recompute()


Arrow-left.svg Previous: Draft CubicBezCurve.svg CubicBezCurve
Next: Point Draft Point.svg Arrow-right.svg